Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| OptaPlanner distribution 6.0.0.CR4-Pre1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.optaplanner.core.impl.score.definition
Class AbstractScoreDefinition<S extends Score>

    java.lang.Object
      org.optaplanner.core.impl.score.definition.AbstractScoreDefinition<S>

All Implemented Interfaces:
  Serializable, ScoreDefinition<S>

Direct Known Subclasses:
  BendableScoreDefinition, HardMediumSoftScoreDefinition, HardSoftBigDecimalScoreDefinition, HardSoftDoubleScoreDefinition, HardSoftLongScoreDefinition, HardSoftScoreDefinition, SimpleBigDecimalScoreDefinition, SimpleDoubleScoreDefinition, SimpleLongScoreDefinition, SimpleScoreDefinition

    public abstract class AbstractScoreDefinition<S extends Score>

extends Object
implements ScoreDefinition<S>, Serializable

Abstract superclass for `ScoreDefinition`.

See Also:
  `ScoreDefinition`, `HardSoftScoreDefinition`, Serialized Form

Constructor Summary
`AbstractScoreDefinition()`

Method Summary
`String` | `formatScore(Score score)` Returns a `String` representation of the `Score`.
`S` | `getPerfectMaximumScore()` The perfect maximum `Score` is the `Score` of which there is no better in any problem instance.
`S` | `getPerfectMinimumScore()` The perfect minimum `Score` is the `Score` of which there is no worse in any problem instance.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.optaplanner.core.impl.score.definition.ScoreDefinition
`buildScoreHolder, calculateTimeGradient, getScoreClass, parseScore`

Constructor Detail

### AbstractScoreDefinition

    public AbstractScoreDefinition()

Method Detail

### getPerfectMaximumScore

    public S getPerfectMaximumScore()

  Description copied from interface: `ScoreDefinition`
  The perfect maximum `Score` is the `Score` of which there is no better in any problem instance. This doesn't mean that the current problem instance, or any problem instance for that matter, could ever attain that `Score`. For example, most cases have a perfect maximum `Score` of zero, as most use cases only have negative constraints.

  Specified by:
    `getPerfectMaximumScore` in interface `ScoreDefinition<S extends Score>`
  Returns:
    null if not supported

### getPerfectMinimumScore

    public S getPerfectMinimumScore()

  Description copied from interface: `ScoreDefinition`
  The perfect minimum `Score` is the `Score` of which there is no worse in any problem instance. This doesn't mean that the current problem instance, or any problem instance for that matter, could ever attain such a bad `Score`. For example, most cases have a perfect minimum `Score` of negative infinity.

  Specified by:
    `getPerfectMinimumScore` in interface `ScoreDefinition<S extends Score>`
  Returns:
    null if not supported

### formatScore

    public String formatScore(Score score)

  Description copied from interface: `ScoreDefinition`
  Returns a `String` representation of the `Score`.

  Specified by:
    `formatScore` in interface `ScoreDefinition<S extends Score>`
  Parameters:
    `score` - never null
  Returns:
    never null
  See Also:
    `ScoreDefinition.parseScore(String)`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| OptaPlanner distribution 6.0.0.CR4-Pre1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2006-2013 JBoss by Red Hat. All Rights Reserved.